Package org.zkoss.zul

## Class Paging

- java.lang.Object
- - org.zkoss.zk.ui.AbstractComponent
  - - org.zkoss.zk.ui.HtmlBasedComponent
    - - org.zkoss.zul.impl.XulElement
      - - org.zkoss.zul.Paging

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Cloneable`, `Component`, `Disable`, `Scope`, `ComponentCtrl`, `Pageable`, `Paginal`
  Direct Known Subclasses:
    `MeshElement.InternalPaging`

      public class Paging
      extends XulElement
      implements Paginal

  Paging of long content.

  Default `getZclass()`: z-paging. (since 3.5.0)

  Author:
    tomyeh
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `HtmlBasedComponent.ExtraCtrl`

    - ### Nested classes/interfaces inherited from class org.zkoss.zk.ui.AbstractComponent

      `AbstractComponent.Children, AbstractComponent.ForwardInfo, AbstractComponent.TargetInfo`

  - ### Field Summary

    - ### Fields inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `_zclass`

    - ### Fields inherited from interface org.zkoss.zk.ui.Component

      `APPLICATION_SCOPE, COMPONENT_SCOPE, DESKTOP_SCOPE, PAGE_SCOPE, REQUEST_SCOPE, SESSION_SCOPE, SPACE_SCOPE`

    - ### Fields inherited from interface org.zkoss.zk.ui.sys.ComponentCtrl

      `AFTER_CHILD_ADDED, AFTER_CHILD_REMOVED, AFTER_CLONED, AFTER_PAGE_ATTACHED, AFTER_PAGE_DETACHED, AFTER_PARENT_CHANGED, CE_BUSY_IGNORE, CE_DUPLICATE_IGNORE, CE_IMPORTANT, CE_NON_DEFERRABLE, CE_REPEAT_IGNORE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Paging()` |
    `Paging​(int totalsz, int pagesz)` | Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `getActivePage()` | Returns the active page (starting from 0).
    `int` | `getPageCount()` | Returns the number of pages.
    `int` | `getPageIncrement()` | Returns the number of page anchors shall appear at the client.
    `int` | `getPageSize()` | Returns the number of items per page.
    `int` | `getTotalSize()` | Returns the total number of items.
    `java.lang.String` | `getZclass()` | Returns the ZK Cascading Style class for this component.
    `boolean` | `isAutohide()` | Returns whether to automatically hide this component if there is only one page available.
    `protected boolean` | `isChildable()` | Returns whether this component can have a child.
    `boolean` | `isDetailed()` | Returns whether to show the detailed info, such as `Paginal.getTotalSize()`.
    `boolean` | `isDisabled()` | Returns whether it is disabled.
    `boolean` | `isVisible()` | Returns whether this component is visible.
    `protected void` | `renderProperties​(ContentRenderer renderer)` | Renders the content of this component, excluding the enclosing tags and children.
    `void` | `service​(AuRequest request, boolean everError)` | Processes an AU request.
    `void` | `setActivePage​(int pg)` | Set the active page
    `void` | `setAutohide​(boolean autohide)` | Sets whether to automatically hide this component if there is only one page available.
    `void` | `setDetailed​(boolean detailed)` | Sets whether to show total size and index of items in current page
    `void` | `setDisabled​(boolean disabled)` | Sets whether it is disabled.
    `void` | `setPageIncrement​(int pginc)` | Sets the number of page list icon when mold is "os"
    `void` | `setPageSize​(int size)` | Sets the items to show in each page
    `void` | `setTotalSize​(int size)` | Sets total size of items

    - ### Methods inherited from class org.zkoss.zul.impl.XulElement

      `clone, getContext, getCtrlKeys, getPopup, getPropertyAccess, getTooltip, setContext, setContext, setContextAttributes, setCtrlKeys, setPopup, setPopup, setPopupAttributes, setTooltip, setTooltip, setTooltipAttributes`

    - ### Methods inherited from class org.zkoss.zk.ui.HtmlBasedComponent

      `addSclass, evalCSSFlex, focus, getAction, getClientAction, getDraggable, getDroppable, getExtraCtrl, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTabindexInteger, getTooltiptext, getTop, getVflex, getWidth, getZindex, getZIndex, removeSclass, removeSclass, setAction, setClass, setClientAction, setDraggable, setDroppable, setFocus, setHeight, setHeight0, setHeightDirectly, setHflex, setHflex0, setHflexDirectly, setLeft, setLeftDirectly, setRenderdefer, setSclass, setStyle, setTabindex, setTabindex, setTooltiptext, setTop, setTopDirectly, setVflex, setVflex0, setVflexDirectly, setWidth, setWidth0, setWidthDirectly, setZclass, setZindex, setZIndex, setZIndexDirectly`

    - ### Methods inherited from class org.zkoss.zk.ui.AbstractComponent

      `addAnnotation, addCallback, addClientEvent, addEventHandler, addEventListener, addEventListener, addForward, addForward, addForward, addForward, addMoved, addRedrawCallback, addScopeListener, addShadowRoot, addShadowRootBefore, addSharedEventHandlerMap, appendChild, applyProperties, beforeChildAdded, beforeChildRemoved, beforeParentChanged, destroyIndexCacheMap, detach, didActivate, didActivate, didDeserialize, didDeserialize, disableBindingAnnotation, disableClientUpdate, disableHostChanged, enableBindingAnnotation, enableHostChanged, getAnnotatedProperties, getAnnotatedPropertiesBy, getAnnotation, getAnnotations, getAnnotations, getAttribute, getAttribute, getAttribute, getAttributeOrFellow, getAttributes, getAttributes, getAuService, getAutag, getCallback, getChildren, getClientAttribute, getClientDataAttribute, getClientEvents, getDefaultMold, getDefinition, getDesktop, getEventHandler, getEventHandlerNames, getEventListenerMap, getEventListeners, getFellow, getFellow, getFellowIfAny, getFellowIfAny, getFellows, getFirstChild, getForwards, getId, getIndexCacheMap, getLastChild, getMold, getNextSibling, getPage, getParent, getPreviousSibling, getRedrawCallback, getRoot, getShadowFellowIfAny, getShadowRoots, getShadowVariable, getShadowVariable, getShadowVariable0, getSpaceOwner, getSpecialRendererOutput, getStubonly, getSubBindingAnnotationCount, getTemplate, getTemplateNames, getUuid, getWidgetAttributeNames, getWidgetClass, getWidgetListener, getWidgetListenerNames, getWidgetOverride, getWidgetOverrideNames, hasAttribute, hasAttribute, hasAttribute, hasAttributeOrFellow, hasBindingAnnotation, hasFellow, hasFellow, hasSubBindingAnnotation, initIndexCacheMap, insertBefore, invalidate, isDisabledHostChanged, isInitialized, isInvalidated, isListenerAvailable, onChildAdded, onChildRemoved, onPageAttached, onPageDetached, onParentChanged, onWrongValue, query, queryAll, redraw, redrawChildren, removeAttribute, removeAttribute, removeAttribute, removeCallback, removeChild, removeEventListener, removeForward, removeForward, removeRedrawCallback, removeScopeListener, removeShadowRoot, render, render, render, renderPropertiesOnly, replace, response, response, response, service, sessionDidActivate, sessionWillPassivate, setAttribute, setAttribute, setAttribute, setAuService, setAutag, setClientAttribute, setClientDataAttribute, setDefinition, setDefinition, setId, setMold, setPage, setPageBefore, setParent, setStubonly, setStubonly, setSubBindingAnnotationCount, setTemplate, setVisible, setVisibleDirectly, setWidgetClass, setWidgetListener, setWidgetOverride, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdate, smartUpdateWidgetListener, smartUpdateWidgetOverride, toString, updateByClient, updateSubBindingAnnotationCount, willPassivate, willPassivate, willSerialize, willSerialize`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.zkoss.zul.ext.Paginal

      `addEventListener, removeEventListener`

- - ### Constructor Detail

    - #### Paging

          public Paging()

    - #### Paging

          public Paging​(int totalsz,
                        int pagesz)

      Constructor.
      Parameters:
        `totalsz` - the total # of items
        `pagesz` - the # of items per page

  - ### Method Detail

    - #### getPageSize

          public int getPageSize()

      Description copied from interface: `Pageable`
      Returns the number of items per page.

      Default: 20.

      Specified by:
        `getPageSize` in interface `Pageable`

    - #### setPageSize

          public void setPageSize​(int size)
                           throws WrongValueException

      Sets the items to show in each page
      Specified by:
        `setPageSize` in interface `Pageable`
      Throws:
        `WrongValueException`

    - #### getTotalSize

          public int getTotalSize()

      Description copied from interface: `Paginal`
      Returns the total number of items.
      Specified by:
        `getTotalSize` in interface `Paginal`

    - #### setTotalSize

          public void setTotalSize​(int size)
                            throws WrongValueException

      Sets total size of items
      Specified by:
        `setTotalSize` in interface `Paginal`
      Throws:
        `WrongValueException`

    - #### getPageCount

          public int getPageCount()

      Description copied from interface: `Pageable`
      Returns the number of pages. Note: there is at least one page even no item at all.
      Specified by:
        `getPageCount` in interface `Pageable`

    - #### getActivePage

          public int getActivePage()

      Description copied from interface: `Pageable`
      Returns the active page (starting from 0).
      Specified by:
        `getActivePage` in interface `Pageable`

    - #### setActivePage

          public void setActivePage​(int pg)
                             throws WrongValueException

      Set the active page

      Note: In server side, active page starts from 0. But in browser UI, it starts from 1

      Specified by:
        `setActivePage` in interface `Pageable`
      Throws:
        `WrongValueException`

    - #### getPageIncrement

          public int getPageIncrement()

      Description copied from interface: `Paginal`
      Returns the number of page anchors shall appear at the client.

      Default: 10.

      Specified by:
        `getPageIncrement` in interface `Paginal`

    - #### setPageIncrement

          public void setPageIncrement​(int pginc)
                                throws WrongValueException

      Sets the number of page list icon when mold is "os"
      Specified by:
        `setPageIncrement` in interface `Paginal`
      Throws:
        `WrongValueException`

    - #### isDetailed

          public boolean isDetailed()

      Description copied from interface: `Paginal`
      Returns whether to show the detailed info, such as `Paginal.getTotalSize()`.
      Specified by:
        `isDetailed` in interface `Paginal`

    - #### setDetailed

          public void setDetailed​(boolean detailed)

      Sets whether to show total size and index of items in current page
      Specified by:
        `setDetailed` in interface `Paginal`

    - #### isAutohide

          public boolean isAutohide()

      Returns whether to automatically hide this component if there is only one page available.

      Default: false.

      Specified by:
        `isAutohide` in interface `Paginal`

    - #### setAutohide

          public void setAutohide​(boolean autohide)

      Sets whether to automatically hide this component if there is only one page available.
      Specified by:
        `setAutohide` in interface `Paginal`

    - #### renderProperties

          protected void renderProperties​(ContentRenderer renderer)
                                   throws java.io.IOException

      Description copied from class: `HtmlBasedComponent`
      Renders the content of this component, excluding the enclosing tags and children.

      See also ZK Client-side Reference: Property Rendering

      Overrides:
        `renderProperties` in class `XulElement`
      Throws:
        `java.io.IOException`

    - #### getZclass

          public java.lang.String getZclass()

      Description copied from class: `HtmlBasedComponent`
      Returns the ZK Cascading Style class for this component. It usually depends on the implementation of the mold (`AbstractComponent.getMold()`).

      Default: null (the default value depends on element).

      `HtmlBasedComponent.setZclass(java.lang.String)`) will completely replace the default style of a component. In other words, the default style of a component is associated with the default value of `HtmlBasedComponent.getZclass()`. Once it is changed, the default style won't be applied at all. If you want to perform small adjustments, use `HtmlBasedComponent.setSclass(java.lang.String)` instead.

      Overrides:
        `getZclass` in class `HtmlBasedComponent`
      See Also:
        `HtmlBasedComponent.getSclass()`

    - #### isVisible

          public boolean isVisible()

      Description copied from interface: `Component`
      Returns whether this component is visible.
      Specified by:
        `isVisible` in interface `Component`
      Overrides:
        `isVisible` in class `AbstractComponent`
      See Also:
        `Components.isRealVisible(org.zkoss.zk.ui.Component)`, `Component.setVisible(boolean)`

    - #### isChildable

          protected boolean isChildable()

      Description copied from class: `AbstractComponent`
      Returns whether this component can have a child.

      Default: return true (means it can have children).

      Overrides:
        `isChildable` in class `AbstractComponent`

    - #### service

          public void service​(AuRequest request,
                              boolean everError)

      Processes an AU request.

      Default: in addition to what are handled by `HtmlBasedComponent.service(org.zkoss.zk.au.AuRequest, boolean)`, it also handles onSelect.

      Specified by:
        `service` in interface `ComponentCtrl`
      Overrides:
        `service` in class `HtmlBasedComponent`
        `everError` - whether any error ever occurred before processing this request.
      Since:
        5.0.0
      See Also:
        `AbstractComponent.setAuService(org.zkoss.zk.au.AuService)`

    - #### isDisabled

          public boolean isDisabled()

      Returns whether it is disabled.

      Default: false.

      Specified by:
        `isDisabled` in interface `Disable`
      Since:
        8.0.3

    - #### setDisabled

          public void setDisabled​(boolean disabled)

      Sets whether it is disabled.
      Specified by:
        `setDisabled` in interface `Disable`
      Since:
        8.0.3